from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  inherit_errexit = 4
  nullglob = 5
  verbose_errexit = 6
  noexec = 7
  xtrace = 8
  verbose = 9
  noglob = 10
  noclobber = 11
  errtrace = 12
  posix = 13
  vi = 14
  emacs = 15
  interactive = 16
  hashall = 17
  failglob = 18
  extglob = 19
  nocasematch = 20
  eval_unsafe_arith = 21
  ignore_flags_not_impl = 22
  ignore_opts_not_impl = 23
  _allow_command_sub = 24
  _allow_process_sub = 25
  dynamic_scope = 26
  redefine_module = 27
  _running_trap = 28
  _running_hay = 29
  _no_debug_trap = 30
  _no_err_trap = 31
  strict_parse_slice = 32
  strict_argv = 33
  strict_arith = 34
  strict_array = 35
  strict_control_flow = 36
  strict_errexit = 37
  strict_nameref = 38
  strict_word_eval = 39
  strict_tilde = 40
  strict_glob = 41
  parse_at = 42
  parse_proc = 43
  parse_func = 44
  parse_brace = 45
  parse_bracket = 46
  parse_equals = 47
  parse_paren = 48
  parse_ysh_string = 49
  parse_triple_quote = 50
  simple_word_eval = 51
  dashglob = 52
  command_sub_errexit = 53
  process_sub_fail = 54
  xtrace_rich = 55
  xtrace_details = 56
  sigpipe_status_ok = 57
  redefine_proc_func = 58
  parse_at_all = 59
  parse_backslash = 60
  parse_backticks = 61
  parse_dollar = 62
  parse_ignored = 63
  parse_sh_arith = 64
  parse_dparen = 65
  parse_dbracket = 66
  parse_bare_word = 67
  simple_echo = 68
  simple_eval_builtin = 69
  simple_test_builtin = 70
  expand_aliases = 71
  lastpipe = 72
  progcomp = 73
  histappend = 74
  hostcomplete = 75
  cmdhist = 76
  assoc_expand_once = 77
  autocd = 78
  cdable_vars = 79
  cdspell = 80
  checkhash = 81
  checkjobs = 82
  checkwinsize = 83
  complete_fullquote = 84
  direxpand = 85
  dirspell = 86
  dotglob = 87
  execfail = 88
  extdebug = 89
  extquote = 90
  force_fignore = 91
  globasciiranges = 92
  globstar = 93
  gnu_errfmt = 94
  histreedit = 95
  histverify = 96
  huponexit = 97
  interactive_comments = 98
  lithist = 99
  localvar_inherit = 100
  localvar_unset = 101
  login_shell = 102
  mailwarn = 103
  no_empty_cmd_completion = 104
  nocaseglob = 105
  progcomp_alias = 106
  promptvars = 107
  restricted_shell = 108
  shift_verbose = 109
  sourcepath = 110
  xpg_echo = 111
  ARRAY_SIZE = 112

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.inherit_errexit',
  5: 'option.nullglob',
  6: 'option.verbose_errexit',
  7: 'option.noexec',
  8: 'option.xtrace',
  9: 'option.verbose',
  10: 'option.noglob',
  11: 'option.noclobber',
  12: 'option.errtrace',
  13: 'option.posix',
  14: 'option.vi',
  15: 'option.emacs',
  16: 'option.interactive',
  17: 'option.hashall',
  18: 'option.failglob',
  19: 'option.extglob',
  20: 'option.nocasematch',
  21: 'option.eval_unsafe_arith',
  22: 'option.ignore_flags_not_impl',
  23: 'option.ignore_opts_not_impl',
  24: 'option._allow_command_sub',
  25: 'option._allow_process_sub',
  26: 'option.dynamic_scope',
  27: 'option.redefine_module',
  28: 'option._running_trap',
  29: 'option._running_hay',
  30: 'option._no_debug_trap',
  31: 'option._no_err_trap',
  32: 'option.strict_parse_slice',
  33: 'option.strict_argv',
  34: 'option.strict_arith',
  35: 'option.strict_array',
  36: 'option.strict_control_flow',
  37: 'option.strict_errexit',
  38: 'option.strict_nameref',
  39: 'option.strict_word_eval',
  40: 'option.strict_tilde',
  41: 'option.strict_glob',
  42: 'option.parse_at',
  43: 'option.parse_proc',
  44: 'option.parse_func',
  45: 'option.parse_brace',
  46: 'option.parse_bracket',
  47: 'option.parse_equals',
  48: 'option.parse_paren',
  49: 'option.parse_ysh_string',
  50: 'option.parse_triple_quote',
  51: 'option.simple_word_eval',
  52: 'option.dashglob',
  53: 'option.command_sub_errexit',
  54: 'option.process_sub_fail',
  55: 'option.xtrace_rich',
  56: 'option.xtrace_details',
  57: 'option.sigpipe_status_ok',
  58: 'option.redefine_proc_func',
  59: 'option.parse_at_all',
  60: 'option.parse_backslash',
  61: 'option.parse_backticks',
  62: 'option.parse_dollar',
  63: 'option.parse_ignored',
  64: 'option.parse_sh_arith',
  65: 'option.parse_dparen',
  66: 'option.parse_dbracket',
  67: 'option.parse_bare_word',
  68: 'option.simple_echo',
  69: 'option.simple_eval_builtin',
  70: 'option.simple_test_builtin',
  71: 'option.expand_aliases',
  72: 'option.lastpipe',
  73: 'option.progcomp',
  74: 'option.histappend',
  75: 'option.hostcomplete',
  76: 'option.cmdhist',
  77: 'option.assoc_expand_once',
  78: 'option.autocd',
  79: 'option.cdable_vars',
  80: 'option.cdspell',
  81: 'option.checkhash',
  82: 'option.checkjobs',
  83: 'option.checkwinsize',
  84: 'option.complete_fullquote',
  85: 'option.direxpand',
  86: 'option.dirspell',
  87: 'option.dotglob',
  88: 'option.execfail',
  89: 'option.extdebug',
  90: 'option.extquote',
  91: 'option.force_fignore',
  92: 'option.globasciiranges',
  93: 'option.globstar',
  94: 'option.gnu_errfmt',
  95: 'option.histreedit',
  96: 'option.histverify',
  97: 'option.huponexit',
  98: 'option.interactive_comments',
  99: 'option.lithist',
  100: 'option.localvar_inherit',
  101: 'option.localvar_unset',
  102: 'option.login_shell',
  103: 'option.mailwarn',
  104: 'option.no_empty_cmd_completion',
  105: 'option.nocaseglob',
  106: 'option.progcomp_alias',
  107: 'option.promptvars',
  108: 'option.restricted_shell',
  109: 'option.shift_verbose',
  110: 'option.sourcepath',
  111: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  readonly = 10
  local = 11
  declare = 12
  typeset = 13
  export_ = 14
  true_ = 15
  false_ = 16
  try_ = 17
  read = 18
  echo = 19
  printf = 20
  mapfile = 21
  readarray = 22
  cd = 23
  pushd = 24
  popd = 25
  dirs = 26
  pwd = 27
  source = 28
  umask = 29
  ulimit = 30
  wait = 31
  jobs = 32
  fg = 33
  bg = 34
  shopt = 35
  complete = 36
  compgen = 37
  compopt = 38
  compadjust = 39
  compexport = 40
  getopts = 41
  builtin = 42
  command = 43
  type = 44
  hash = 45
  help = 46
  history = 47
  alias = 48
  unalias = 49
  bind = 50
  append = 51
  write = 52
  json = 53
  json8 = 54
  pp = 55
  hay = 56
  haynode = 57
  module = 58
  use = 59
  error = 60
  failed = 61
  fork = 62
  forkwait = 63
  fopen = 64
  shvar = 65
  ctx = 66
  runproc = 67
  boolstatus = 68
  test = 69
  bracket = 70
  push_registers = 71
  is_main = 72
  cat = 73
  ARRAY_SIZE = 74

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.readonly',
  11: 'builtin.local',
  12: 'builtin.declare',
  13: 'builtin.typeset',
  14: 'builtin.export_',
  15: 'builtin.true_',
  16: 'builtin.false_',
  17: 'builtin.try_',
  18: 'builtin.read',
  19: 'builtin.echo',
  20: 'builtin.printf',
  21: 'builtin.mapfile',
  22: 'builtin.readarray',
  23: 'builtin.cd',
  24: 'builtin.pushd',
  25: 'builtin.popd',
  26: 'builtin.dirs',
  27: 'builtin.pwd',
  28: 'builtin.source',
  29: 'builtin.umask',
  30: 'builtin.ulimit',
  31: 'builtin.wait',
  32: 'builtin.jobs',
  33: 'builtin.fg',
  34: 'builtin.bg',
  35: 'builtin.shopt',
  36: 'builtin.complete',
  37: 'builtin.compgen',
  38: 'builtin.compopt',
  39: 'builtin.compadjust',
  40: 'builtin.compexport',
  41: 'builtin.getopts',
  42: 'builtin.builtin',
  43: 'builtin.command',
  44: 'builtin.type',
  45: 'builtin.hash',
  46: 'builtin.help',
  47: 'builtin.history',
  48: 'builtin.alias',
  49: 'builtin.unalias',
  50: 'builtin.bind',
  51: 'builtin.append',
  52: 'builtin.write',
  53: 'builtin.json',
  54: 'builtin.json8',
  55: 'builtin.pp',
  56: 'builtin.hay',
  57: 'builtin.haynode',
  58: 'builtin.module',
  59: 'builtin.use',
  60: 'builtin.error',
  61: 'builtin.failed',
  62: 'builtin.fork',
  63: 'builtin.forkwait',
  64: 'builtin.fopen',
  65: 'builtin.shvar',
  66: 'builtin.ctx',
  67: 'builtin.runproc',
  68: 'builtin.boolstatus',
  69: 'builtin.test',
  70: 'builtin.bracket',
  71: 'builtin.push_registers',
  72: 'builtin.is_main',
  73: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

